

const int L9110S_1A =  2;      //   A控制的前進（HIGH）、後退（LOW）
const int L9110S_1B =  15;      //   B控制馬達的速度 0~1023

const int L9110S_2A =  12;      //   A控制的前進（HIGH）、後退（LOW）
const int L9110S_2B =  4;      //   B控制馬達的速度 0~1023

// setting PWM properties
const int freq = 5000;        //freq輸出頻率，建議值5000 Hz
const int ledChannel0 = 0;     //LEDChannel設定為0-15
const int ledChannel1 = 1;     //LEDChannel設定為0-15
const int resolution = 10;    //resolution代表輸出解析度，例如8代表0-255，10代表0-1023



void setup() {
  Serial.begin(115200);
  Serial.println();

  pinMode(L9110S_1A, OUTPUT);
  pinMode(L9110S_2A, OUTPUT);


  ledcSetup(ledChannel0, freq, resolution);
  ledcAttachPin(L9110S_1B, ledChannel0);

  ledcSetup(ledChannel1, freq, resolution);
  ledcAttachPin(L9110S_2B, ledChannel1);

  
}
void Motor(int speed_val)
{
  if (speed_val >= 0) {
      digitalWrite(L9110S_1A , HIGH);
      ledcWrite(ledChannel0, 1023-speed_val);
      digitalWrite(L9110S_2A , HIGH);
      ledcWrite(ledChannel1, 1023-speed_val);
                    
  } else {
      digitalWrite(L9110S_1A , LOW);
      ledcWrite(ledChannel0, -(speed_val));
      digitalWrite(L9110S_2A , LOW);
      ledcWrite(ledChannel1, -(speed_val));
     
  }
                 
}



void loop() {

 Serial.println("Motor Forward Fast Speed");
 Motor(1023);//正轉 1~1023
 delay(2000); 
 Serial.println("Motor Forward Slow Speed");
 Motor(500);//正轉 1~1023
 delay(2000); 
 Serial.println("Motor Reverse Fast Speed");
 Motor(-1023);//反轉 -1~ -1023
 delay(2000);
 Serial.println("Motor Reverse Slow Speed");
 Motor(-500);//反轉 -1~ -1023
 delay(2000);
 Serial.println("Motor Stop");
 Motor(0); //停止
 delay(2000);

 

  
  
}
